Bug 1163665 - Node can temporarily read removed data when another node joins the cluster, leaves or crashes
Summary: Node can temporarily read removed data when another node joins the cluster, l...
Keywords:
Status: ASSIGNED
Alias: None
Product: JBoss Data Grid 6
Classification: JBoss
Component: Infinispan
Version: 6.4.0
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
: ---
Assignee: Pedro Ruivo
QA Contact: Martin Gencur
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-11-13 09:10 UTC by Radim Vansa
Modified: 2018-01-30 01:45 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Known Issue
Doc Text:
In Red Hat JBoss Data Grid, the distribution of entries in the cluster changes when a node joins, leaves or crashes. During this brief period, a read on the previous node owner can return stale data. When the rebalance process is completed, further reads return up-to-date data. This is a known issue in JBoss Data Grid 6.4 and no workaround is currently available for this issue.
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
JBoss Issue Tracker ISPN-4444 Critical Resolved After state transfer, a node is able to read keys it no longer owns from its data container 2018-02-28 22:34:57 UTC
JBoss Issue Tracker ISPN-5021 Critical Resolved Nodes that finish the rebalance later can see outdated values 2018-02-28 22:34:57 UTC

Description Radim Vansa 2014-11-13 09:10:15 UTC

Comment 2 JBoss JIRA Server 2014-11-17 14:44:48 UTC
Pedro Ruivo <pruivo@redhat.com> updated the status of jira ISPN-4444 to Coding In Progress

Comment 3 JBoss JIRA Server 2014-11-26 10:13:31 UTC
Dan Berindei <dberinde@redhat.com> updated the status of jira ISPN-4444 to Reopened

Comment 6 JBoss JIRA Server 2014-12-17 16:45:04 UTC
Pedro Ruivo <pruivo@redhat.com> updated the status of jira ISPN-5021 to Coding In Progress

Comment 7 Tristan Tarrant 2014-12-23 09:00:26 UTC
I think we should split this bug in two and mark this issue as resolved

Comment 8 Pedro Ruivo 2015-01-05 11:17:43 UTC
this is a tricky one. I'm currently work on it but I think the solution I have in mind will solve it.

Comment 9 Radim Vansa 2015-01-05 16:21:22 UTC
The stale value can be read only for a brief period of time.

Since we want rather *eventual* consistency than guarantee up-to-date reads in crash/join/leave/split-brain scenarios, this issue is not critical to JDG.

Comment 11 Radim Vansa 2015-01-07 08:35:47 UTC
Any resilience tests had trouble with https://bugzilla.redhat.com/show_bug.cgi?id=1166243 . I need to test this yet further, but it seems that partition handling is behaving as expected, since the cache is allowed to become inconsistent/provide stale data in certain time window.

Comment 13 Radim Vansa 2015-01-09 08:33:31 UTC
This BZ is related to reading stale data, not inconsistent result of writes. What BZ would you like me to verify?

Described test setup is possible.


Note You need to log in before you can comment on or make changes to this bug.